<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_TipoGarantia.xml */
/* Generado: 2020-08-18 04:21:28 */

/* Validacion del contenido de los campos campos de la tabla MST_TipoGarantia */
abstract class BaseMST_TipoGarantiaBV extends MST_TipoGarantiaBN
{
    /* Contiene la clase que valida el tipo de dato */
    private $o_Validator; // Contiene el objeto que realizara la validacion de tipo de dato.
    private $s_ValidatorMessage; // Contiene la ultima observacion de la validacion del tipo de dato.

    /* Constructor ( Establece la clase que valida los tipos de datos y establece los valores por defecto ) */
    public function __construct()
    {
        /* Establecemos el objeto que realizara la validacion del tipo de dato */
        $this->o_Validator = new utilValidDataType();

        /* Establecemos los valores por defecto */
    }

    /* Valida en tipo de dato */
    private function validateData( $u_Data, $s_DataType, $i_Length, $i_Decimal, $b_NotNull )
    {
        $this->s_ValidatorMessage = null;
        if( !$this->o_Validator->validate( $u_Data, $s_DataType, $i_Length, $i_Decimal, $b_NotNull ) )
        {
            $this->s_ValidatorMessage = $this->o_Validator->getMessage();
        }
        return is_null( $this->s_ValidatorMessage );
    }

    /* Valida y establece el valor del campo TipoGarantiaId */
    public function setTipoGarantiaId( $i_TipoGarantiaId, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $i_TipoGarantiaId, "INT", 11, 0, false ) )
            {
                throw new Exception( "El campo TipoGarantiaId ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setTipoGarantiaId( $i_TipoGarantiaId );
        return true;
    }

    /* Valida y establece el valor del campo Nombre */
    public function setNombre( $s_Nombre, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_Nombre, "VARCHAR", 100, 0, false ) )
            {
                throw new Exception( "El campo Nombre ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setNombre( $s_Nombre );
        return true;
    }

    /* Valida y establece el valor del campo NumeroDias */
    public function setNumeroDias( $f_NumeroDias, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $f_NumeroDias, "FLOAT", 0, 0, false ) )
            {
                throw new Exception( "El campo NumeroDias ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setNumeroDias( $f_NumeroDias );
        return true;
    }

    /* Valida el contenido del registro */
    public function validateRecord()
    {
        $this->setTipoGarantiaId( $this->getTipoGarantiaId(), false );
        $this->setNombre( $this->getNombre(), true );
        $this->setNumeroDias( $this->getNumeroDias(), true );
        return true;
    }
}
?>